defmodule Pandoc.Watcher do
  use GenServer

  def start_link(args) do
    GenServer.start_link(__MODULE__, args)
  end

  def init([profile | args]) do
    IO.puts("pandoc filesystem watcher init args #{inspect(args)}")

    IO.puts(
      "Application.get_env(:pandoc, :#{profile}): #{inspect(Application.get_env(:pandoc, profile))}"
    )

    {:ok, watcher_pid} = FileSystem.start_link(args)
    FileSystem.subscribe(watcher_pid)
    {:ok, %{watcher_pid: watcher_pid}}
  end

  def handle_info({:file_event, watcher_pid, {path, events}}, %{watcher_pid: watcher_pid} = state) do
    case {Path.extname(path), :closed in events} do
      {".md", true} -> Pandoc.run(path)
      _ -> nil
    end

    {:noreply, state}
  end

  def handle_info({:file_event, watcher_pid, :stop}, %{watcher_pid: watcher_pid} = state) do
    # Your own logic when monitor stop
    {:noreply, state}
  end
end
